// ArbitrageurAgent.h

// ArbitrageurAgent


#import "BasicSumAgent.h"
#import "IndexCalculator.h"

@interface ArbitrageurAgent: BasicSumAgent
{
  int buySellSwitchFuture, buySellSwitchShares, arbitrageurGain, arbitrageurOperatingIntervalFixed;
  float arbitrageurOperatingInterval,  indexValue, realFuturePrice, indexSpread,
        newIndexValue, futureSpread, sumOfPrice;

  IndexCalculator * indexCalculator;
  //Book * aBook;
}

- setArbitrageurOperatingInterval: (float) i;
- setArbitrageurOperatingIntervalFixed: (int) i;
- setArbitrageurGain: (int) i;
- setIndexCalculator: t;

- act0;
- act1;  // placing buy or sell orders

@end
