// AvatarAgent.h

// AvatarAgent inherits from BasicSumAgent and operates with human order;

#import "BasicSumAgent.h"
#import <simtools.h>


@interface AvatarAgent: BasicSumAgent
{
	int currentDay,continuosMarket, eventStateAvatar, humanPenalty,numberOfTransaction ;
	float penalty,oldPenalty,transaction,oldTransaction, oldAgentWealthAtMeanDailyPrice, lowTransactionCost, highTransactionCost;
}

- setContinuosMarket: (int) n;
- setPenalty: (int) p;
- onlineExperimentPenaltyAccounting;
- penaltyAccounting;
- createEnd;
- communicateEvent1;
- communicateEvent2;
- communicateEvent3;
- communicateEvent4;
- orderConfirmationFrom: (int) theBookNumber atPrice:(float) price;
- act0; // acting - placing buy or sell orders - before opening
- act1;  // placing buy or sell orders
- act2;

@end
