// BPCTPriceRuleMaster.h 

// This is the RandomRuleMaster, guiding the behavior of RandomAgent, 
// MarketImitatingAgent, LocallyImitatingAgent

#import "BasicSumRuleMaster.h"

@interface BPCTPriceRuleMaster: BasicSumRuleMaster
{
  id <UniformDoubleDist> myUniformDblRand;

}

- setMyUniformDblRand: u; // an ad hoc distribution, see comment in 
                          // modelSwarm.h and .m

- (float) getPriceBeforeOpening: (float) lp;
- (float) getPrice: (float) lp;

@end

