// BPCTPriceRuleMaster.m                                        

#import "BPCTPriceRuleMaster.h"

@implementation BPCTPriceRuleMaster


- setMyUniformDblRand: u
{
  myUniformDblRand = u;
  return self;
}

- (float) getPriceBeforeOpening: (float) lastPrice
{
  if (agentProbToActBeforeOpening <
     (float) [myUniformDblRand getDoubleWithMin: 0.0 withMax: 1.0])
   return 0.0;
  else return [self getPrice: lastPrice];
}

// here we determine only the price, unsigned, (buy or sell side is a choice of the ANN
// within to BPCT agent)
- (float) getPrice: (float) lastPrice 
{
  float price;
  price = lastPrice * (float)
      [myUniformDblRand getDoubleWithMin: minCorrectingCoeff + asymmetricRange
                               withMax: maxCorrectingCoeff + asymmetricRange];

  return price;
}

@end



