// BasicSumAgent.h

// This is the root Agent in Sum; all operating agents inherit from it,
// but ForecastingAgent; also CTAgent must inherit from it, to have
// accounting capality

#import <objectbase/SwarmObject.h>
#import <random.h>
#import <math.h> // to use fabs etc.
#import "Book.h"
#import "EventGenerator.h"
#import <simtoolsgui/GUISwarm.h> // to use CREATE_ARCHIVED_PROBE_DISPLAY
#import <simtoolsgui.h>          // ""
#import "Matrix2.h"

@interface BasicSumAgent: SwarmObject
{

  int number, maxOrderQuantity, maxOrderQuantity2, iMax, executedPriceCount,
  printing, delay, actingBeforeOpening, actingAtTheTime, bookNumber;
  // we can use at maximum 1000 books, if you want to use more, you need to change the number in the brackets
  float shareQuantityVector[1000];
  float price,
        asymmetricBuySellProb, buySellSwitch,
        shareQuantity, shareValueAtMeanDailyPrice,
        liquidityQuantity, agentWealthAtMeanDailyPrice,
        meanOperatingPrice;
  Matrix2 * executedPrices;
  Book * oneBook;
  EventGenerator * eventGenerator;
  Book * theBook;// da eliminare a fine modifiche
  id <Index> bookArrayIndex;

}

- createEnd;

- setNumber: (int) n;
- setEventGenerator: eg;
- setAsymmetricBuySellProb: (float) p;
- setMaxOrderQuantity: (int) m;
- setMaxOrderQuantity2: (int) m;
//- setForecastingAgentArrayIndex: i;
- setBookArrayIndex: i;
- setBookNumber: (int) m;

- (float) getMeanPrice: (int) n;
- setBook: b;
- setPrinting: (int) p;
- setDelay: (int) d;

- setConfirmationOfExecutedPrice: (float) p inBook: (int) m;
- orderConfirmationFrom: (int) theBookNumber atPrice:(float) price;

- actPrepare;
- act0; // defined for compatibilty reasons with currentAgent
- act1;  // "" ""
- act2; // accounting at the end of a day
- getProbe;
- (float) getWealthAtMeanDailyPrice;
- (int) getRandomBookNumber;

- (float) getPrice2: (int) n;
- setOrderBeforeOpeningFromAgent2: (int) n ofAgent: (int) m atPrice: (float) p;
- setOrderFromAgent2: (int) n ofAgent: (int) m atPrice: (float) p;

/*
- (float) getPrice(id <Index> bookArrayIndex, int n);
- (void) setOrderBeforeOpeningFromAgent(id <Index> bookArrayIndex, int n, int number, float price);
- (void) setOrderFromAgent(id <Index> bookArrayIndex, int n, int number, float price);
*/
/*- (float) getPrice;
- (void) setOrderBeforeOpeningFromAgent;
- (void) setOrderFromAgent;*/
@end


