// EventAgent.m

#import "EventAgent.h"

@implementation EventAgent

  // our ruleMaster
- setRuleMaster: r
{
  ruleMaster=r;
  return self;
}

  // Acting before opening
- act0
{
   float lastPrice, lastEvent;
   int i;

   randomBookNumber=[self getRandomBookNumber];

   buySellSwitch=0.5; // the standard random choice situation

   lastPrice=[self getPrice2: randomBookNumber];
   lastEvent=[eventGenerator getEventState];


   // Asking the ruleMaster for a position (if eventState is > 0 we are
   // buyers; if it is <0 we are sellers; if it is =0 we act like randomAgent
   price=[ruleMaster getPriceBeforeOpening: lastPrice
                     withEventState: lastEvent
			   withBuySellP: buySellSwitch];

   if (price!=0) actingBeforeOpening=1;

   // how many orders?
   if (maxOrderQuantity==1) iMax=1;
    else iMax=[uniformIntRand getIntegerWithMin: 1 withMax: maxOrderQuantity];
   for (i=1;i<=iMax;i++)
   //if price==0 theBook is not recording it
   [self setOrderBeforeOpeningFromAgent2: randomBookNumber ofAgent:  number atPrice:  price];

   return self;
}

  // acting in the market
- act1
{
   float lastPrice, lastEvent;
   int i;

   randomBookNumber=[self getRandomBookNumber];

   buySellSwitch=0.5; // the standard random choice situation

   // the agent has operated before opening
   if (actingBeforeOpening==1) return self;

   lastPrice=[self getPrice2: randomBookNumber];
   lastEvent=[eventGenerator getEventState];

   price=[ruleMaster getPrice: lastPrice
                     withEventState: lastEvent
		         withBuySellP: buySellSwitch];


   // how many orders?
   if (maxOrderQuantity==1) iMax=1;
    else iMax=[uniformIntRand getIntegerWithMin: 1 withMax: maxOrderQuantity];
   for (i=1;i<=iMax;i++)
   [self setOrderFromAgent2: randomBookNumber ofAgent: number atPrice:  price];

   return self;
}

@end






