// MarketImitatingAgent.h

// MarketImitatingAgent inherits from BasicSumAgent and operates in an
// imitative way, following market tendency;
// anyway, in case of price sliding below the floor price, a buying behavior
// prevails

#import "BasicSumAgent.h"
#import "RandomRuleMaster.h"

@interface MarketImitatingAgent: BasicSumAgent
{
  RandomRuleMaster * ruleMaster;
  int randomBookNumber;
  Book * aBook;
}

- setRuleMaster: r;

- act0; // acting - placing buy or sell orders - before opening
- act1;  // placing buy or sell orders

-(float) chooseBuySellSwitch: (int) m with: (float) a;

@end
