// MarketImitatingAgent.m

#import "MarketImitatingAgent.h"

@implementation MarketImitatingAgent


  // our ruleMaster
- setRuleMaster: r
{
  ruleMaster=r;
  return self;
}

  // Acting before opening
- act0
{
   randomBookNumber=[self getRandomBookNumber];
   float lastPrice;
   int i;

   // imitating the market
//   buySellSwitch=chooseBuySellSwitch(randomBookNumber, asymmetricBuySellProb);
buySellSwitch=[self chooseBuySellSwitch:randomBookNumber with: asymmetricBuySellProb];

   lastPrice=[self getPrice2: randomBookNumber];

   // Asking the ruleMaster for a position (if the price is > 0 we are
   // buyer; if it is <0 we are seller; if it is =0 we do nothing
   // the ruleMaster uses in this case the probability of operating
   // before opening
   price=[ruleMaster getPriceBeforeOpening: lastPrice
                     withBuySellP: buySellSwitch];

   if (price!=0) actingBeforeOpening=1;

   // how many orders?
   if (maxOrderQuantity==1) iMax=1;
    else iMax=[uniformIntRand getIntegerWithMin: 1 withMax: maxOrderQuantity];
   for (i=1;i<=iMax;i++)
   // if price==0 theBook is not recording it
   [self setOrderBeforeOpeningFromAgent2: randomBookNumber ofAgent:  number atPrice:  price];
printf("ciao imito il mercato in preaapertura   ");
   return self;
}

  // acting in the market
- act1
{
   randomBookNumber=[self getRandomBookNumber];
   float lastPrice;
   int i;

   // the agent has operated before opening
   if (actingBeforeOpening==1) return self;

   // imitating the market
   //buySellSwitch=chooseBuySellSwitch(randomBookNumber, asymmetricBuySellProb);
buySellSwitch=[self chooseBuySellSwitch:randomBookNumber with: asymmetricBuySellProb];

   lastPrice=[self getPrice2: randomBookNumber];

   price=[ruleMaster getPrice: lastPrice
                     withBuySellP: buySellSwitch];


   // how many orders?
   if (maxOrderQuantity==1) iMax=1;
    else iMax=[uniformIntRand getIntegerWithMin: 1 withMax: maxOrderQuantity];
   for (i=1;i<=iMax;i++)
   [self setOrderFromAgent2: randomBookNumber ofAgent: number atPrice:  price];
printf("ciao imito il mercato nel durante    ");
   return self;
}

// static to avoid 'duplicate name' error (the function is defined also
// in the .m files of other kinds of agent; the content anyway is different)

-(float) chooseBuySellSwitch: (int) m with: (float) a
{

  [bookArrayIndex setOffset: m-1];
  aBook=[bookArrayIndex get];

  float b, lagged1MeanPrice, lagged2MeanPrice;

   b=0.5; // the standard random choice situation

   lagged1MeanPrice=[aBook getLaggedMeanPrice: 1]; // the mean price in t-1
                                                     // (previous period)
   lagged2MeanPrice=[aBook getLaggedMeanPrice: 2]; // the mean price in t-2

   // imitating the market; the probability of buying is
   // asymmetricBuySellProb  if lagged1MeanPrice > lagged2MeanPrice and
   // (1-asym...)            if lagged1MeanPrice < lagged2MeanPrice
       if(lagged1MeanPrice > lagged2MeanPrice)b=
                                              a;
       if(lagged1MeanPrice < lagged2MeanPrice)b=
                                              1-a;

  return b;
}


@end






