// RandomAgent.m

#import "RandomAgent.h"
#include <unistd.h>





@implementation RandomAgent

  // our ruleMaster
- setRuleMaster: r
{
  ruleMaster=r;
  return self;
}

  // Acting before opening
- act0
{
   randomBookNumber=[self getRandomBookNumber];
   float lastPrice;
   int i;

   buySellSwitch=0.5; // the standard random choice situation

   lastPrice=[self getPrice2: randomBookNumber];

   // Asking the ruleMaster for a position (if the price is > 0 we are
   // buyer; if it is <0 we are seller; if it is =0 we do nothing
   // the ruleMaster uses in this case the probability of operating
   // before opening
   price=[ruleMaster getPriceBeforeOpening: lastPrice
                     withBuySellP: buySellSwitch];

   if (price!=0) actingBeforeOpening=1;

   // how many orders?
   if (maxOrderQuantity==1) iMax=1;
    else iMax=[uniformIntRand getIntegerWithMin: 1 withMax: maxOrderQuantity];
   for (i=1;i<=iMax;i++)
   // if price==0 theBook is not recording it

   [self setOrderBeforeOpeningFromAgent2: randomBookNumber ofAgent:  number atPrice:  price];

   return self;
}

  // acting in the market
- act1
{
   randomBookNumber=[self getRandomBookNumber];
   float lastPrice;
   int i;



	sleep(delay);



   buySellSwitch=0.5; // the standard random choice situation

   // the agent has operated before opening
   //if (actingBeforeOpening==1) return self;

   lastPrice=[self getPrice2: randomBookNumber];

   price=[ruleMaster getPrice: lastPrice
                     withBuySellP: buySellSwitch];


   // how many orders?
   if (maxOrderQuantity==1) iMax=1;
    else iMax=[uniformIntRand getIntegerWithMin: 1 withMax: maxOrderQuantity];
   for (i=1;i<=iMax;i++)
   [self setOrderFromAgent2: randomBookNumber ofAgent: number atPrice:  price];

   return self;
}

@end






