#!/bin/sh
alias rm='rm -f'
umask 000

  export START=$(date '+%Y-%m-%d_%H.%M.%S')
  printf "$START" >> data/run.log

rm sumweb-multi/Day-1*
rm sumweb-multi/Prop*
rm sumweb-multi/Back*
rm sumweb-multi/Current\ price*
rm sumweb-multi/Sell\ orders*
rm sumweb-multi/Buy\ orders*
rm sumweb-multi/Buy\ orders*
rm sumweb-multi/MinWealth*
rm sumweb-multi/MaxWealth*
rm sumweb-multi/MeanWealth*
rm sumweb-multi/data/*
rm sumweb-multi/avatardata/*
rm sumweb-multi/log/*
rm sumweb-multi/Index\ Value
rm sumweb-multi/Events
rm sumweb-multi/Qty*
rm sumweb-multi/Price*

 
  ./sum
  
  export GIORNO=$(date '+%Y-%m-%d_%H.%M.%S')

        # Orders Prices OHLC
  tar -cf data/${GIORNO}.tar bookdata*.dat 
  tar -cf data/${GIORNO}.tar bookohlc*.dat 
  tar -rf data/${GIORNO}.tar order-history.dat
	# Day 
  tar -rf data/${GIORNO}.tar dayhistory.dat
  tar -rf data/${GIORNO}.tar acceptedorder.dat
	# Prices  
  tar -rf data/${GIORNO}.tar Current\ price*
  tar -rf data/${GIORNO}.tar Day-1* 
  tar -rf data/${GIORNO}.tar Index\ Value  
	#  Agent Wealth 
  tar -rf data/${GIORNO}.tar MinWealth* MeanWealth* MaxWealth* 
	# Humans  
  tar -rf data/${GIORNO}.tar avatardata/*
  tar -rf data/${GIORNO}.tar log/*
	# Volumes  
  tar -rf data/${GIORNO}.tar Price*  
  tar -rf data/${GIORNO}.tar Qty*
	# Events data
  tar -rf data/${GIORNO}.tar Events
	# Book data
  tar -rf data/${GIORNO}.tar Buy* 
  tar -rf data/${GIORNO}.tar Sell*
	# Forecasting Agent
  tar -rf data/${GIORNO}.tar Proportional*
  tar -rf data/${GIORNO}.tar Back*
	# BPCT Agent
  tar -rf data/${GIORNO}.tar meanPrice*
  tar -rf data/${GIORNO}.tar liquidityQuantity_*
  tar -rf data/${GIORNO}.tar shareQuantity_*
  tar -rf data/${GIORNO}.tar buySell_*
  tar -rf data/${GIORNO}.tar forecasted*
  tar -rf data/${GIORNO}.tar closing*

  gzip data/${GIORNO}.tar
  rm bookdatashort*.dat Current\ price* MinWealth* MeanWealth* MaxWealth* Day-1* Qty* Proportional* Price* Buy* Sell* Back*
  rm meanPrice* liquidityQuantity_* shareQuantity_* buySell_* forecasted* closing* 
  rm bookohlcshort*.dat *.pl Events
  rm Index\ Value
  printf "\t$GIORNO\n" >> data/run.log


