// EventGenerator.h

#import <objectbase/SwarmObject.h>
#import <random.h>
#import <simtools.h>      // necessary to invoke ObjectLoader -> Serve?
#import <simtoolsgui/GUISwarm.h> // to use CREATE_ARCHIVED_PROBE_DISPLAY
#import <simtoolsgui.h>          // ""
//#import "AvatarAgent.h"
#import <collections.h>

@interface EventGenerator: SwarmObject
{

  int eventType, changeState, changeEvent,eventStateAvatar;

  float eventChangeProbability, eventState, variance, secondFlex, firstFlex;

  id <NormalDist> myNormalDistRand;
  id <List> avatarAgentList;



}

- createEnd;

// set the event type, the probability that an event can change its state (active or inactive) and its sensibility
- setStart: (int) s;
- setMyNormalDistRand: u;
- setEventType: (int) et;
- setEventChangeProbability: (float) ecp;
- setAvatarAgentList: l;

// this method is used to put in working the event generator: it returns the state and hence
// the intensity of the event
- setEventState;
- (float) getEventState;

@end




