// LocallyImitatingAgent.m

#import "LocallyImitatingAgent.h"




@implementation LocallyImitatingAgent


  // our ruleMaster
- setRuleMaster: r
{
  ruleMaster=r;
  return self;
}

  // Acting before opening
- act0
{
   randomBookNumber=[self getRandomBookNumber];
   float lastPrice;
   int i;

   // imitating the market
buySellSwitch=[self chooseBuySellSwitch:randomBookNumber with: asymmetricBuySellProb];

   lastPrice=[self getPrice2: randomBookNumber];

   // Asking the ruleMaster for a position (if the price is > 0 we are
   // buyer; if it is <0 we are seller; if it is =0 we do nothing
   // the ruleMaster uses in this case the probability of operating
   // before opening
   price=[ruleMaster getPriceBeforeOpening: lastPrice
                     withBuySellP: buySellSwitch];

   if (price!=0) actingBeforeOpening=1;

   // how many orders?
   if (maxOrderQuantity==1) iMax=1;
    else iMax=[uniformIntRand getIntegerWithMin: 1 withMax: maxOrderQuantity];
   for (i=1;i<=iMax;i++)
   // if price==0 theBook is not recording it
   [self setOrderBeforeOpeningFromAgent2: randomBookNumber ofAgent:  number atPrice:  price];
printf("ciao imito il mercato LOCALMENTE in preaapertura   ");

   return self;
}

  // acting in the market
- act1
{
   randomBookNumber=[self getRandomBookNumber];
   float lastPrice;
   int i;

   // the agent has operated before opening
   if (actingBeforeOpening==1) return self;

   // imitating the market
buySellSwitch=[self chooseBuySellSwitch:randomBookNumber with: asymmetricBuySellProb];

   lastPrice=[self getPrice2: randomBookNumber];

   price=[ruleMaster getPrice: lastPrice
                     withBuySellP: buySellSwitch];


   // how many orders?
   if (maxOrderQuantity==1) iMax=1;
    else iMax=[uniformIntRand getIntegerWithMin: 1 withMax: maxOrderQuantity];
   for (i=1;i<=iMax;i++)
   [self setOrderFromAgent2: randomBookNumber ofAgent: number atPrice:  price];
printf("ciao imito il mercato LOCALMENTE nel durante    ");

   return self;
}


// static to avoid 'duplicate name' error (the function is defined also
// in the .m files of other kinds of agent; the content anyway is different)
//static float chooseBuySellSwitch(id theBook, float asymmetricBuySellProb)
-(float) chooseBuySellSwitch: (int) m with: (float) a
{
  float b;
  [bookArrayIndex setOffset: m-1];
  aBook=[bookArrayIndex get];
   b=0.5; // the standard random choice situation

   // Deciding of imitating the local history
   if([aBook getLocalHistory]>0) // locally buying decisions prevail
                                   // (buying prob = asymmetricaBuySellProb)
                                  b=a;
   if([aBook getLocalHistory]<0) // locally selling decisions prevail
                                   // (buying prob = 1 - asym...)
                                  b=1-a;

  return b;
}

@end






