// Matrix2.h  (this version adds local methods to Matrix class of bp-ct)

#import <objectbase/SwarmObject.h>
#import "Matrix.h"

@interface Matrix2: Matrix
{

}

// to retrieve the row number
- (int) getRows;

// to shift nr rows down of one row
- shiftRowsDown: (int) nr;

// to push all the rows down of one row, from 0 to nrows-1
- pushRowsDown;

// to file a price in col 0, inserting it in increasing order
- fileIncreasingP: (float) p andN: (float) n usingAsNumberOfRows: (int) nr;

// to file a price in col 0, inserting it in decreasing order
- fileDecreasingP: (float) p andN: (float) n usingAsNumberOfRows: (int) nr;

// to add auctionMatrix prices
- fileAddP: (float) p fromRow: (int) frn  withExecutableOrders:(int) exe  withBalanceness: (int) b withAbsoluteDifference: (float) ab usingAsNumberOfRows: (int) nr;


// to show the content of n rows (mainly while debugging)
- printNRows: (int) nr;

// to print the content of n rows to a file

- printNRowsFileB: (int) nr ofBook: (int) bn;
- printNRowsFileS: (int) nr ofBook: (int) bn;

@end


// 'Code' is only used to identify error messages related to an array







