<?php
require("conf.php");


echo "<HTML>
<head>
<meta http-equiv=Refresh CONTENT=\"$candlestickPageRefresh\">
</head>

<BODY bgcolor=\"#000000\">
<title>$book[$ib]: analysis</title>";






/******************************************

Simple Moving Average

******************************************/



Function sma($arrayproc, $window){
$sma=array();

  for ($i=1;$i<=(count($arrayproc));$i++) {
    $sum=0;

	if ($i>=($window)){

	    for ($ii=$i;$ii>=($i-($window-1));$ii--) {
		  $sum=$sum+$arrayproc[$ii];
		}

	$onesma=$sum/$window;
	$sma[$i]=$onesma;

    }else{
    $sma[$i]="-";
    }

	}

return $sma;
};




/******************************************

Relative Strong Index

******************************************/



Function rsi($open,$close, $window){
$rsi=array();

  for ($i=1;$i<=(count($open));$i++) {    

	if ($i>=($window)){
		$rsi_pos=0;
		$rsi_neg=0;
		$onersi=0;	
	    for ($ii=$i;$ii>=($i-($window-1));$ii--) {
		  $delta=$close[$ii]-$open[$ii];
		  if ($delta>=0){$rsi_pos=$rsi_pos+$delta;}else{$rsi_neg=$rsi_neg+$delta;}
		  
		  if(($rsi_pos==0.0)&&(abs($rsi_neg)==0.0)){$onersi=0.0;}else
		  {$onersi=(($rsi_pos-abs($rsi_neg))/($rsi_pos+abs($rsi_neg)))*100;}
		  $onersi=$onersi/2+50;
		}

	$rsi[$i]=$onersi;

    }else{
    $rsi[$i]="-";
    }

	}

return $rsi;
};


/******************************************

Ploticus drawing tools

******************************************/

exec('tail -'.$dataToBeDrawInCandlestick.' bookohlc'.$ib.'.dat > bookohlcshort'.$ib.'.dat');


$fp = fopen('bookohlcshort'.$ib.'.dat', "r");
  if (!$fp) {
    echo "<p>Errore nell'apertura del file remoto.\n";
    exit;
  }
  
$fp2 = fopen('bookohlcshort'.$ib.'.mod.dat',"w");
  if (!$fp2) {
    echo "<p>Errore nell'apertura del file remoto.\n";
    exit;
  }
  

$i=1;

while ($userinfo = fscanf ($fp, "%d\t%f\t%f\t%f\t%f\t%f\n")) {
    list ($date[$i], $open[$i], $high[$i], $low[$i], $close[$i], $volumes[$i] ) = $userinfo;
$i++;
}

$rsi=array();
$sma=array();
$rsi= rsi($open,$close,$rsiwindow);
$sma= sma($close,$smawindow);


//echo "<table>";

for($i=1;$i<=count($open);$i++){
    fwrite($fp2, "$i\t$open[$i]\t$high[$i]\t$low[$i]\t$close[$i]\t$volumes[$i]\t$rsi[$i]\t$sma[$i]\n");


//print("<tr><td>$i</td><td> $open[$i]</td><td> $high[$i]</td><td> $low[$i]</td><td> $close[$i]</td><td> $volumes[$i]</td><td> $rsi[$i]</td><td> $sma[$i]</td></tr>\n");

}
//echo "</table>";
fclose($fp);
fclose($fp2);



















Function drawploticus($ploticusexe,$book, $ib, $dataToBeDrawInCandlestick,$rsiwindow,$smawindow){



exec('tail -'.$dataToBeDrawInCandlestick.' bookohlc'.$ib.'.dat > bookohlcshort'.$ib.'.dat');


$fp = fopen('bookohlcshort'.$ib.'.dat', "r");
  if (!$fp) {
    echo "<p>Errore nell'apertura del file remoto.\n";
    exit;
  }
  
$fp2 = fopen('bookohlcshort'.$ib.'.mod.dat',"w");
  if (!$fp2) {
    echo "<p>Errore nell'apertura del file remoto.\n";
    exit;
  }
  

$i=1;

while ($userinfo = fscanf ($fp, "%d\t%f\t%f\t%f\t%f\t%f\n")) {
    list ($date[$i], $open[$i], $high[$i], $low[$i], $close[$i], $volumes[$i] ) = $userinfo;
$i++;
}

$rsi= rsi($open,$close,$rsiwindow);
$sma= sma($close,$smawindow);

for($i=1;$i<=count($open);$i++){
    fwrite($fp2, "$i\t$open[$i]\t$high[$i]\t$low[$i]\t$close[$i]\t$volumes[$i]\t$rsi[$i]\t$sma[$i]\n");
}

fclose($fp);
fclose($fp2);

$maxprice=max($high);
$minprice=min($low);
$maxvolumes=max($volumes);
$minvolumes=min($volumes);

$ystubinc=round(($maxprice-$minprice)/4,2);
$ystubinc2=round(($maxvolumes-$minvolumes)/3,2);
 
$xstubinc=round($i/8,2); 




//apro e scrivo il file impostazioni di ploticus

 $fp = fopen ('charttech'.$ib.'.pl', "w");

/**********************************
**          Style                **
**********************************/

    fwrite($fp, "#proc page \n");
    fwrite($fp, "#if @DEVICE in gif,png \n");
    fwrite($fp, "  scale: 0.7 \n");
    fwrite($fp, "#endif \n");


//    fwrite($fp, "#proc page \n");
    fwrite($fp, "backgroundcolor: black \n");
    fwrite($fp, "color: white \n");


    fwrite($fp, "#proc getdata \n");
    fwrite($fp, "file: bookohlcshort".$ib.".mod.dat\n");
    fwrite($fp, "delimit: tab \n");
    fwrite($fp, "fieldnames: date open high low close volume rsi sma\n");



    fwrite($fp, "#proc areadef \n");
    fwrite($fp,   "title: ".$book[$ib]."\n");

    fwrite($fp, "rectangle: 1 3.8 10 7.8 \n");
    fwrite($fp, "xscaletype: linear \n");
    fwrite($fp, "xautorange: datafield=date \n");
    fwrite($fp, "yautorange: datafield=open,high,low,close \n");
    fwrite($fp, "yscaletype: linear \n");
    fwrite($fp, "#saveas: A \n");


    fwrite($fp, "#proc xaxis \n");
    fwrite($fp, "stubs: inc ".$xstubinc." \n");

    fwrite($fp, "grid: color=skyblue  \n");
//    fwrite($fp, "tics: none \n");
    fwrite($fp, "#saveas: XAX \n");

// set up Y axis using proc yaxis
    fwrite($fp, "#proc yaxis \n");
    fwrite($fp, "stubs: inc ".$ystubinc." \n");
    fwrite($fp, "grid: color=skyblue  \n");
    fwrite($fp, "axisline: none \n");
    fwrite($fp, "tics: none \n");

// draw white (up) candlestick bars using proc bars
// thin high/low bar..
    fwrite($fp, "#proc bars \n");
    fwrite($fp, "select: @@close > @@open \n");
    fwrite($fp, "locfield: date \n");
    fwrite($fp, "segmentfields: low high \n");
    fwrite($fp, "thinbarline: width=0.3 color=white \n");

// thicker open/close bar..
    fwrite($fp, "#proc bars \n");
    fwrite($fp, "select: @@close > @@open \n");
    fwrite($fp, "locfield: date \n");
    fwrite($fp, "segmentfields: open close \n");
    fwrite($fp, "barwidth: 0.04 \n");
    fwrite($fp, "outline: no \n");
    fwrite($fp, "color: white \n");

// draw gray(0.4) (down) candlestick bars using proc bars
// thin high/low bar..
    fwrite($fp, "#proc bars \n");
    fwrite($fp, "select: @@close <= @@open \n");
    fwrite($fp, "locfield: date \n");
    fwrite($fp, "segmentfields: low high \n");
    fwrite($fp, "thinbarline: width=0.3 color=gray(0.4) \n");

// thicker open/close bar..
    fwrite($fp, "#proc bars \n");
    fwrite($fp, "select: @@close <= @@open \n");
    fwrite($fp, "locfield: date \n");
    fwrite($fp, "segmentfields: open close \n");
    fwrite($fp, "barwidth: 0.04 \n");
    fwrite($fp, "outline: no \n");
    fwrite($fp, "color: gray(0.4) \n");


	// Prezzo di chiusura in linea continua
	fwrite($fp, "#proc lineplot \n");
	fwrite($fp, "xfield: date \n");
	fwrite($fp, "yfield: sma \n");
	fwrite($fp, "linedetails: width=0.5 color=red style=0 \n");



// do volume

// define bottom plotting area using proc areadef
    fwrite($fp, "#proc areadef \n");
    fwrite($fp, "#clone: A \n");
// 1 1.6 5 2.6
    fwrite($fp, "rectangle: 1 2.4 10 3.4 \n");
    fwrite($fp, "yautorange: datafield=volume \n");
//yrange: 0 5000000
    fwrite($fp, "yscaletype: linear \n");
    fwrite($fp, "title: Volumes \n");
    //fwrite($fp, "#saveas: B \n");


// set up X axis using proc xaxis
    fwrite($fp, "#proc xaxis \n");
//    fwrite($fp, "label: Volume (1000s)
    fwrite($fp, "ticincrement: ".$xstubinc."  \n");
    
    fwrite($fp, "grid: color=skyblue  \n");
    fwrite($fp, "labeldetails: adjust=0,0.2 size=8 \n");
    fwrite($fp, "axisline: none \n");
    //fwrite($fp, "tics: none \n");

// set up Y axis using proc yaxis
    fwrite($fp, "#proc yaxis \n");
    fwrite($fp, "stubs: inc ".$ystubinc2." \n");
    fwrite($fp, "grid: color=skyblue  \n");
    fwrite($fp, "axisline: none \n");
    fwrite($fp, "tics: none \n");

// render histogram using proc bars
    fwrite($fp, "#proc bars \n"); 
    fwrite($fp, "barwidth: 0.04 \n");
    fwrite($fp, "color: dullyellow \n");
    fwrite($fp, "locfield: 1 \n");
    fwrite($fp, "lenfield: 6 \n");
    fwrite($fp, "outline: no \n");



    
// do rsi

// define bottom plotting area using proc areadef
    fwrite($fp, "#proc areadef \n");
    fwrite($fp, "#clone: A \n");
// 1 1.6 5 2.6
    fwrite($fp, "rectangle: 1 1 10 2 \n");
    fwrite($fp, "yrange: 0 100 \n");
//yrange: 0 5000000
    fwrite($fp, "yscaletype: linear \n");
    fwrite($fp, "title: RSI \n");

// set up X axis using proc xaxis
    fwrite($fp, "#proc xaxis \n");
//    fwrite($fp, "label: Volume (1000s)
    fwrite($fp, "ticincrement: ".$xstubinc."  \n");
    fwrite($fp, "grid: color=skyblue  \n");
//    fwrite($fp, "labeldetails: adjust=0,0.2 size=8 \n");
    fwrite($fp, "axisline: none \n");
//    fwrite($fp, "tics: none \n");

// set up Y axis using proc yaxis
    fwrite($fp, "#proc yaxis \n");
    fwrite($fp, "stubs: inc 20 \n");
    fwrite($fp, "grid: color=skyblue  \n");
    fwrite($fp, "axisline: none \n");
    fwrite($fp, "tics: none \n");    

	// Prezzo di chiusura in linea continua
	fwrite($fp, "#proc lineplot \n");
	fwrite($fp, "xfield: date \n");
	fwrite($fp, "yfield: rsi \n");
	fwrite($fp, "linedetails: width=0.5 color=red style=0 \n");


 fclose($fp);




exec($ploticusexe.' -gif charttech'.$ib.'.pl -o charttech'.$ib.'.gif');


}



if (!file_exists('charttech'.$ib.'.gif')){ if(file_exists('bookohlc'.$ib.'.dat')){drawploticus($ploticusexe,$book, $ib,$dataToBeDrawInCandlestick,$rsiwindow,$smawindow);}
}else{if ((time() - filemtime('charttech'.$ib.'.gif')>$secondsForRefresh)&&file_exists('bookohlc'.$ib.'.dat')) drawploticus($ploticusexe,$book, $ib,$dataToBeDrawInCandlestick,$rsiwindow,$smawindow);}

if (file_exists('charttech'.$ib.'.gif')){
	print ('<img src="');
	print('charttech'.$ib.'.gif');
	print ('">');
}



?>    


</BODY>
</HTML>
